# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "maw"
version = "0.17.0"
authors = ["Srlion <srlion32@gmail.com>"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "A simple and efficient web framework for Rust."
readme = "README.md"
license = "MIT"
repository = "https://github.com/Srlion/maw"

[features]
default = []
full = [
    "xml",
    "minijinja",
    "middleware",
]
middleware = [
    "middleware-cookie",
    "middleware-session",
    "middleware-logging",
    "middleware-csrf",
    "middleware-catch_panic",
    "middleware-body_limit",
]
middleware-body_limit = []
middleware-catch_panic = ["dep:pin-project-lite"]
middleware-cookie = ["dep:cookie"]
middleware-csrf = [
    "middleware-cookie",
    "dep:rand",
    "dep:constant_time_eq",
]
middleware-logging = []
middleware-session = [
    "middleware-cookie",
    "serde/derive",
]
minijinja = [
    "dep:minijinja",
    "dep:erased-serde",
]
xml = ["dep:quick-xml"]

[lib]
name = "maw"
path = "src/lib.rs"

[dependencies.bytes]
version = "1"

[dependencies.constant_time_eq]
version = "0.4.2"
optional = true

[dependencies.cookie]
version = "0.18"
features = [
    "private",
    "signed",
]
optional = true

[dependencies.erased-serde]
version = "0.4"
optional = true

[dependencies.futures-core]
version = "0.3.31"

[dependencies.http]
version = "1"

[dependencies.http-body]
version = "1.0.1"

[dependencies.http-body-util]
version = "0.1"

[dependencies.hyper]
version = "1"
features = []

[dependencies.hyper-util]
version = "0.1"
features = [
    "server",
    "server-graceful",
    "http1",
]

[dependencies.matchit]
version = "0.9"

[dependencies.mime_guess]
version = "2"

[dependencies.minijinja]
version = "2"
features = [
    "loader",
    "builtins",
    "json",
]
optional = true

[dependencies.paste]
version = "1"

[dependencies.pin-project-lite]
version = "0.2.16"
optional = true

[dependencies.quick-xml]
version = "0.38"
features = ["serialize"]
optional = true

[dependencies.rand]
version = "0.9.2"
features = ["thread_rng"]
optional = true
default-features = false

[dependencies.serde]
version = "1"
features = []

[dependencies.serde_json]
version = "1"

[dependencies.serde_urlencoded]
version = "0.7"

[dependencies.smol_str]
version = "0.3"

[dependencies.thiserror]
version = "2"

[dependencies.tokio]
version = "1"
features = [
    "signal",
    "net",
]

[dependencies.tokio-util]
version = "0.7.17"

[dependencies.tracing]
version = "0.1"
